package sdelatorre.carautobluetooth.com;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Vector;
import java.util.concurrent.CancellationException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;



public class AlmacenPuntuacionesSW_PHP_Async_Task implements AlmacenPuntuaciones {
	 
	private Context contexto;
	public Boolean guardado=false;
	 
	public AlmacenPuntuacionesSW_PHP_Async_Task(Context contexto) {
	       this.contexto = contexto;
	}
	
	
    public Vector<String> listaPuntuaciones(String pass) {
    	   try {
               TareaLista tarea = new TareaLista();
               tarea.execute(pass);
               return tarea.get(4, TimeUnit.SECONDS);
         } catch (TimeoutException e) {
               Toast.makeText(contexto, "Tiempo excedido al conectar",
                             Toast.LENGTH_LONG).show();
         } catch (CancellationException e) {
               Toast.makeText(contexto, "Error al conectar con servidor",
                             Toast.LENGTH_LONG).show();
         } catch (Exception e) {
            Toast.makeText(contexto, "Error con tarea asncrona",
                          Toast.LENGTH_LONG).show();
         }
    	   
         return new Vector<String>();
          
     
    }
    
    public void guardarPuntuacion(String dias, String pass, int hora,int minutos,long fecha) {
    	  try {
              TareaGuardar tarea = new TareaGuardar();
              tarea.execute(dias, pass,String.valueOf(hora),String.valueOf(minutos),String.valueOf(fecha));
          
              tarea.get(4, TimeUnit.SECONDS);
          if (guardado){
    		  Toast.makeText(contexto, "Datos guardados en servidor", Toast.LENGTH_LONG).show();
    		  
    	  }
              
          	
        } catch (TimeoutException e) {
              Toast.makeText(contexto, "Tiempo excedido al conectar",
                            Toast.LENGTH_LONG).show();
        } catch (CancellationException e) {
              Toast.makeText(contexto, "Error al conectar con servidor",
                            Toast.LENGTH_LONG).show();
              Toast.makeText(contexto, "Error"+e.getMessage(), Toast.LENGTH_LONG).show();
        } catch (Exception e) {
              Toast.makeText(contexto, "Error con tarea asncrona",
                            Toast.LENGTH_LONG).show();
        }
    	
}
    
  

	private class TareaLista extends AsyncTask<String, Void, Vector<String>>{
    	  @Override
    	  protected Vector<String> doInBackground(String... pass){
    		  Vector<String> result = new Vector<String>();
              
              
              try {
                 URL url=new URL("http://frontenisappandroid.eu5.org/carautoblue/lista.php"+ "?max=1"
              +"&pass="+pass[0]);
            	// URL url= new URL("http://frontenisappandroid.eu5.org/carautoblue/lista.php?max=1&pass=00");   
                     Log.d("url","es"+url);
                     HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
                     if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                            BufferedReader reader = new BufferedReader(new
                                   InputStreamReader(conexion.getInputStream()));
                            String linea = reader.readLine();
                            while (!linea.equals("")) {
                                   result.add(linea);
                                   linea = reader.readLine();
                            }
                            reader.close();
                           
                           // Toast.makeText(contexto, "Datos cargados", Toast.LENGTH_SHORT).show();
                                
                            return result;
                     } else {
                                        cancel(true);
                                   return result;
                            }
              } catch (Exception e) {
                         cancel(true);
                     return result;
              }
              
    	  }
    
}
    private class TareaGuardar extends AsyncTask<String, Void, Void> {
        @Override
        protected Void doInBackground(String... param) {
              try {
                     URL url = new URL(
                            "http://frontenisappandroid.eu5.org/carautoblue/nueva.php"
                                         + "?dias=" + param[0]+ "&pass="
                                         + URLEncoder.encode(param[1], "UTF-8")
                                         + "&hora=" + param[2]
                                         + "&minutos="+param[3]
                                         + "&fecha="+param[4]		 );

                   //  Log.d("url","es"+url);
                      HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
                         if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                                BufferedReader reader = new BufferedReader(new
                                             InputStreamReader(conexion.getInputStream()));
                                
                                String linea = reader.readLine();
                                if (!linea.equals("OK")) {
                                	
                                    	cancel(true);
                                }
                         } else {
                                     	
                                cancel(true);
                         }
                         guardado=true;
                         
                         conexion.disconnect();
                  } catch (Exception e) {
                	                     cancel(true);
                  }
         
                     return null;
        }
        
      
    }
    
    }
