package sdelatorre.carautobluetooth.com;

import java.util.Vector;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.AlertDialog;
import android.app.ActivityManager.RunningServiceInfo;
import android.app.TimePickerDialog;
import android.app.TimePickerDialog.OnTimeSetListener;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.StrictMode;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;

import android.widget.ImageView;
import android.widget.TextView;
import android.widget.TimePicker;
import android.widget.Toast;


public class MainActivity extends Activity implements OnClickListener,OnTimeSetListener {

	
	public static String estado="parado";
	public static boolean parada_tecnica=false,bluetooth;
	public static boolean app=false;
	private ImageView dia,hora,conf,internet,blu,blueoff,car_t;
	private TextView c,b,t;
	public static AlmacenPuntuaciones almacen;
	private TimePicker horas;
	
	
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		//receptor_mensaje();

		if (getIntent().getExtras() != null){
			super.onCreate(savedInstanceState);
		dialogo(this);
		
		}else{
			setTheme(android.R.style.Theme_Black_NoTitleBar);
			super.onCreate(savedInstanceState);
			setContentView(R.layout.activity_main);	
			
			setup();
			comprueba_blu();
			comprueba_app();
			//dialogo(this);
		}
		
	}
	private void comprueba_app() {
		
		if (app){
			  blu.setImageResource(R.drawable.ic_media_play_on);
		}else{
			 blu.setImageResource(android.R.drawable.ic_media_play);
			  
		}
	
	}
	private void comprueba_blu() {
		BluetoothAdapter blue = BluetoothAdapter.getDefaultAdapter();
		if (blue == null) {
		  
		} else {
		    if (blue.isEnabled()) {
		        blueoff.setImageResource(R.drawable.ic_blue_off);
		        bluetooth=true;
		        
		    }else{
		    	  blueoff.setImageResource(R.drawable.ic_blue_on);
		    	  bluetooth=false;
		    }
		}
		
	}
	private void setup() {
		
		dia =(ImageView) findViewById(R.id.dia);
		 hora =(ImageView) findViewById(R.id.hora);
		 blu =(ImageView) findViewById(R.id.blu);
		 conf =(ImageView) findViewById(R.id.conf);
		 internet =(ImageView) findViewById(R.id.internet);
		 blueoff=(ImageView) findViewById(R.id.blueoff);
		 horas=(TimePicker) findViewById(R.id.horas);
		 horas.setIs24HourView(true);
		 car_t=(ImageView) findViewById(R.id.car_t);
		 c=(TextView) findViewById(R.id.c);
		 b=(TextView) findViewById(R.id.b);
		 t=(TextView) findViewById(R.id.t);
				 
		 dia.setOnClickListener(this);
		 hora.setOnClickListener(this);
		 conf.setOnClickListener(this);
		 blu.setOnClickListener(this);
		 internet.setOnClickListener(this);
		 blueoff.setOnClickListener(this);
		 horas.setOnClickListener(this);
		 
		 animation_element(R.id.dia,1000,R.anim.slide_left);
		 animation_element(R.id.hora,1000,R.anim.slide_right);
		 animation_element(R.id.blu,1000,R.anim.hyperspace_in);
		 animation_element(R.id.blueoff,1000,R.anim.hyperspace_in);
		 animation_element(R.id.internet,1000,R.anim.slide_right);
		 animation_element(R.id.conf,1000,R.anim.slide_left);
		 animation_element(R.id.car_t,2000,R.anim.slide_left);
		 animation_element(R.id.c,2100,R.anim.slide_left);
		 animation_element(R.id.b,2200,R.anim.slide_left);
		 animation_element(R.id.t,2400,R.anim.slide_left);
		 sonido(R.raw.engine);
		
	}
	private void sonido(int recurso) {
		MediaPlayer mp=MediaPlayer.create(this,recurso);
		mp.start();
		
		
	}
	private void dialogo(Context context) {
		AlertDialog.Builder builder = new AlertDialog.Builder(context);
		// Add the buttons
		
		builder.setMessage("BLUETOOTH?");
		builder.setPositiveButton("SI", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		            
		             finish();
		             
		             
		           }
		       });
		builder.setNegativeButton("NO", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		        	   parada_tecnica=true;
		        	   BluetoothAdapter blue = BluetoothAdapter.getDefaultAdapter();
			    		if (blue == null) {
			    		  
			    		} else {
			    		    if (blue.isEnabled()) {
			    		    	blue.disable();
			    		    	}
			    		    }
		           }
		       });
	
		AlertDialog dialog = builder.create();
		  dialog.requestWindowFeature(Window.FEATURE_LEFT_ICON);
		  dialog.setIcon(R.drawable.ic_launcher);
		  WindowManager.LayoutParams wmlp = dialog.getWindow().getAttributes();
		 wmlp.gravity = Gravity.BOTTOM| Gravity.CENTER;
		 dialog.show();
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
	//	getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	@Override
	public void onClick(View arg0) {
		sonido(R.raw.clickbutton);
		int duracion=1000;
		switch (arg0.getId()){
		
		case R.id.dia:
			abrir_app("dia");
			 animation_element(arg0.getId(),duracion,R.anim.hyperspace_out);
			break;
		case R.id.hora:
			
			 animation_element(arg0.getId(),duracion,R.anim.hyperspace_out);
			mostrar_hora();
			
			 break;
		case R.id.conf:
			abrir_app("conf");
			 animation_element(arg0.getId(),duracion,R.anim.hyperspace_out);
			break;
			
			//boton play
		case R.id.blu:
			 animation_element(arg0.getId(),duracion,R.anim.shake);
			
			 if (app){
				 blu.setImageResource(android.R.drawable.ic_media_play);
				 app=false;
				 if (isMyServiceRunning(ServicioEstado.class,this))
				 	{
					 this.stopService((new Intent(this, ServicioEstado.class)));    
				 	}
			 }else{ 
				 	blu.setImageResource(R.drawable.ic_media_play_on);
				 	app=true;
				 if (bluetooth){
				if (Receptorbluetooth.comprobar_dia(this) && Receptorbluetooth.comprobar_hora(this)) {
					if (!MainActivity.isMyServiceRunning(ServicioEstado.class,this)){
		        		Log.d("servicio","si");
		        		 this.startService((new Intent(this, ServicioEstado.class)));
		        		 //comprueba si se desactiva automticamente
		        		 Receptorbluetooth.desactiva_blue(this);
					} 
				
			 }
				 }
			 }
			break;
		case R.id.blueoff:
			 activa_blue();	
			
			 break;
			
		case R.id.internet:
			guardar_blue();	
			 animation_element(arg0.getId(),duracion,R.anim.hyperspace_out);
			break;
		}
		
	}

	private void mostrar_hora() {
	
		
		SharedPreferences pref = this.getSharedPreferences("sdelatorre.carautobluetooth.com_preferences", Context.MODE_PRIVATE);
		int hora_selec=pref.getInt("hora", 0);
		int min_selec=pref.getInt("minutos", 0);
		
		TimePickerDialog mishoras=new TimePickerDialog(this, this, hora_selec,min_selec, true);
		mishoras.setTitle("Fin jornada laboral");
		mishoras.setIcon(R.drawable.ic_launcher);
	
		mishoras.show();
		
		
	}

	private void guardar_blue() {

 final SharedPreferences  pref = this.getSharedPreferences("sdelatorre.carautobluetooth.com_preferences", Context.MODE_PRIVATE);
		
	if (pref.getString("password", "0").equals("0")){
			
			Toast.makeText(this, "POR FAVOR ENTRA EN CONFIGURACIN Y CAMBIA TU PASSWORD",Toast.LENGTH_LONG).show();
     
	}else{
		servicio_web();
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage("Cargar o guardar datos al servidor?");
		builder.setPositiveButton("Cargar", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		            
		        	   AlmacenPuntuaciones almacen= new  AlmacenPuntuacionesSW_PHP_Async_Task(getBaseContext());
		       		
		        	   
		             Vector<String> datos=almacen.listaPuntuaciones(pref.getString("password", "0"));
		           
		           if (datos.isEmpty()){
		            	Toast.makeText(MainActivity.this, "Compruebe conexin o password", Toast.LENGTH_LONG).show();
		            	
		            }else{
		            	Toast.makeText(MainActivity.this, "Datos cargados", Toast.LENGTH_LONG).show();
		  		      
		            	String dato=datos.firstElement();
		            	
		            	
		            	int primer=dato.indexOf("-");
		            	String dias=dato.substring(0,dato.indexOf("-"));
		            	String restante=dato.substring(primer+1,dato.length());
		            	int horas=restante.indexOf("-");		            	
		            	String hora=restante.substring(0,restante.indexOf("-"));
		            	String min=restante.substring(horas+1,restante.length());
		            	
		            	SharedPreferences pref = getBaseContext().getSharedPreferences("sdelatorre.carautobluetooth.com_preferences", Context.MODE_PRIVATE);
		            	SharedPreferences.Editor editor=pref.edit();
		            	editor.putInt("hora", Integer.valueOf(hora));
		            	editor.putInt("minutos", Integer.valueOf(min));
		            	
		            	for (int i=1; i < 8; i++){					  
							  if (dias.contains(String.valueOf(i))){
								editor.putBoolean(String.valueOf(i), true);

							  }
							 
		            	
		            	}
		             
		            	 editor.commit();
		             
		            	}
		           }
		       });
		builder.setNegativeButton("Guardar", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		        	     String pass=((pref.getString("password", "0")));	
		        		 int hora=pref.getInt("hora", 0);
		        		 int minutos=pref.getInt("minutos", 0);
		        		 String dias="";
		        		for (int i=1; i < 8; i++){					  
							  if (pref.getBoolean(String.valueOf(i), false)){

								  dias=dias+(String.valueOf(i));
							  }
						        }
		       
		        			AlmacenPuntuaciones almacen= new  AlmacenPuntuacionesSW_PHP_Async_Task(getBaseContext());
			        		almacen.guardarPuntuacion(dias,pass,hora,minutos,System.currentTimeMillis());
			        		
		           }
		       });
		builder.setTitle("AUTOBLUETOOTH");
		builder.setIcon(R.drawable.ic_launcher);	
		builder.show();}
		
	}
	private void servicio_web() {
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitNetwork().build());
		
	}
	private void activa_blue() {
		BluetoothAdapter blue = BluetoothAdapter.getDefaultAdapter();
		if (blue == null) {
		  
		} else {
		    if (!blue.isEnabled()) {
		      
		        blue.enable();
		        blueoff.setImageResource(R.drawable.ic_blue_off);
		        animation_element(R.id.blueoff,4000,R.anim.shake);
		       bluetooth=true;
		        
		    }else{ 
		    	blue.disable();
		    	blueoff.setImageResource(R.drawable.ic_blue_on);
		    	animation_element(R.id.blueoff,1000,R.anim.shake);
		    	bluetooth=false;
	   
		    	
		    }
		
		}
		
	}
	private void abrir_app(String abrir){
		Intent myIntent = new Intent(this.getApplicationContext(), Preferencias.class);
		Bundle bundle = new Bundle();
		bundle.putString("abrir", abrir);
		myIntent.putExtras(bundle);
		startActivity(myIntent);
	}
	private void animation_element(int mover,int dur,int anim){
			
		Animation element = AnimationUtils.loadAnimation(this, anim);
	    element.setDuration(dur);
		findViewById(mover).startAnimation(element);
}
	public static boolean isMyServiceRunning(Class<?> serviceClass,Context con) {
    ActivityManager manager = (ActivityManager) con.getSystemService(Context.ACTIVITY_SERVICE);
    for (RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
        if (serviceClass.getName().equals(service.service.getClassName())) {
            return true;
        }
    }
    return false;
}
	@Override
	public void onTimeSet(TimePicker arg0, int arg1, int arg2) {
		
	SharedPreferences pref = this.getSharedPreferences("sdelatorre.carautobluetooth.com_preferences", Context.MODE_PRIVATE);
	SharedPreferences.Editor editor=pref.edit();
	editor.putInt("hora", arg1);
	editor.putInt("minutos", arg2);
	editor.commit();
	}
}
