package sdelatorre.carautobluetooth.com;

import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.IBinder;
import android.support.v4.app.NotificationCompat;


public class ServicioEstado extends Service implements LocationListener {

	private LocationManager manejador_estado;
	private String proveedor_estado;
	private Location  localizacion_inicial = null;
	private static int TIEMPO_MIN_ESTADO = 60 * 1000; // 60 segundos
	private static final long DISTANCIA_MIN_ESTADO = 0; // 5 metros
	private int ID_NOTIF = 2;
	
	private long date_ini=0,date_fin;
	
	
	private float v = 0;

	public ServicioEstado() {
		// TODO Auto-generated constructor stub
	}

	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		super.onCreate();

	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		// TODO Auto-generated method stub

		
		setup_manejador();
		flags=START_STICKY;
		notifica_barra_estado(this);
		return super.onStartCommand(intent, flags, startId);

		
	}

	void setup_manejador() {
		
		SharedPreferences pref = this.getSharedPreferences("sdelatorre.carautobluetooth.com_preferences", Context.MODE_PRIVATE);
				
		manejador_estado = (LocationManager) getSystemService(LOCATION_SERVICE);

		Criteria criterio = new Criteria();
		criterio.setCostAllowed(false);
		criterio.setAltitudeRequired(false);
		criterio.setAccuracy(Criteria.ACCURACY_FINE);
		
		String LOCALIZACION=((pref.getString("configurarposicionamiento", "2")));
		
		
		
		switch (LOCALIZACION){
		case "0": proveedor_estado=LocationManager.GPS_PROVIDER;
				break;
		case "1":proveedor_estado=LocationManager.NETWORK_PROVIDER;
			break;
		case "2":proveedor_estado = manejador_estado.getBestProvider(criterio, true);
			break;
			}
	
		
;
		TIEMPO_MIN_ESTADO=Integer.parseInt((pref.getString("configurartiempoposicionamiento", "60000")));
				
		manejador_estado.requestLocationUpdates(proveedor_estado,TIEMPO_MIN_ESTADO*60*1000, DISTANCIA_MIN_ESTADO, this);

	}

	private void comprueba_estado(Location localizacion2) {

		
		date_fin=localizacion2.getTime();
		
			
		if (localizacion_inicial!=null){
			
				
			v = (localizacion2.distanceTo(localizacion_inicial))/ ((date_fin-date_ini)/1000);
		/*	Toast.makeText(this, "DIST " + localizacion2.distanceTo(localizacion_inicial), Toast.LENGTH_SHORT).show();
			Toast.makeText(this, "TIEMPO " + ((date_fin-date_ini)/1000), Toast.LENGTH_SHORT).show();
			Toast.makeText(this, "VELOCIDAD " + v, Toast.LENGTH_SHORT).show();
			Toast.makeText(this, "estado " + MainActivity.estado, Toast.LENGTH_SHORT).show();
			*/
			
			//comrueba si supera los 10km/h
			if (v>2.7){
				MainActivity.estado="coche";
				
				}else {MainActivity.estado="parado";}
		}
	
		localizacion_inicial = localizacion2;
		date_ini=date_fin;
		

	}


	@Override
	public void onLocationChanged(Location loc) {

		comprueba_estado(loc);

	}

	@Override
	public void onProviderDisabled(String arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onProviderEnabled(String arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onStatusChanged(String arg0, int arg1, Bundle arg2) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onDestroy() {
		manejador_estado.removeUpdates(this);
		borrar_notifica_estado(this);
		
		super.onDestroy();
	}
	private void borrar_notifica_estado(ServicioEstado servicioEstado) {
			
		NotificationManager notificationManager = (NotificationManager)this.getSystemService(Context.NOTIFICATION_SERVICE);
		notificationManager.cancel(ID_NOTIF);
		
	}

	private void notifica_barra_estado(Context cont) {
		
    	NotificationCompat.Builder notific = new NotificationCompat.Builder(cont)   
    		.setContentTitle("CarBluetooth activada")
                .setSmallIcon(R.drawable.abc_ic_go)
                .setWhen(System.currentTimeMillis())
                .setTicker("CarBluetooth controlando movimiento")
                .setVibrate(new long[] { 100,100,100,300,300,300 });
    	
   NotificationManager notificationManager = (NotificationManager)cont.getSystemService(Context.NOTIFICATION_SERVICE);

  PendingIntent intencionPendiente = PendingIntent.getActivity(
		    getApplicationContext(),
		    0,
		    new Intent(), // add this
		    0);
  
 	notific.setContentIntent(intencionPendiente);
	notific.setOngoing(true);	
	
   notificationManager.notify(ID_NOTIF, notific.build());
  
	
	}
}